//pl0程序（算法及程序实现参见请见张昱和陈意云编写的《编译原理与技术》，高等教育出版社，2010.8）的验证
//要点：
   //1.pl0程序分成编译器和解释器两个部分，本验证文件只考虑编译器部分，解释器的验证暂不考虑；
   //2.为简单起见，pl0程序编译器部分的验证也只限于合法的pl0程序。如果pl0程序不合法（存在语法或语义错误），程序直接退出；
   //3.本文件只是对pl0程序编译器部分进行部分正确性验证，即合法的pl0程序符合pl0语言的语法规则、生成的中间代码结构正确、符号表能正确收集各种信息。
//关键字：变量不变式、归纳谓词、逻辑函数、幽灵代码、宏定义

#include <stdio.h>
#include "specification.h"

//@ ghost symArray symStream;        //用于为一个源文件存放词法分析得到的符号流，以用于验证“为每种语法构造的实例都生成对应的目标代码序列”。
//@ ghost integer symStreamIndex = 0;
//@ ghost _Bool stop_here, program_file_cannot_be_opened, can_not_get_the_infile_name,can_not_close_file;

/////////////////////////////////////main函数的验证///////////////////////////////////////
//main函数验证的性质：
//源文件中的pl0程序符合pl0语法规则
//生成对应的的中间代码结构正确
/*@
requires 
        cc == 1 && ll == 1 && ch == line[cc] && lev == 0 && tx == 0 && cx == 0
        ;
assigns    program_file_cannot_be_opened, stop_here, can_not_get_the_infile_name, infile, a, id, kk, cc, ll, err, sym, dx, cx, tx, table, lev, symStreamIndex, symStream[0..\infinity], code[0..cxmax],
        too_many_error, nested_level_too_shallow, program_incomplete, program_line_overflow, can_not_close_file, too_many_variables, num, line, ch, program_too_long, symbol_table_too_short;
                                                        // a开始是临时增加的子句
ensures 
        Block(symStream, 0, symStreamIndex-1) && symStream[symStreamIndex] == period 
        && ProgramCode(code, 0, cx-1) && \result == 0
        ;
exits \exit_status == 1 && program_file_cannot_be_opened == true 
      || \exit_status == 2 && stop_here == true 
      || \exit_status == 3 && can_not_get_the_infile_name == true
      || \exit_status == 4 && can_not_close_file == true
      ;
*/
int main(){
    int ret;

    printf("%s\n", "please input source program file name: ");
    ret = scanf("%79s", infilename);
    if(ret < 1){
        printf("%s\n", "can not get the infile name");
        //@ ghost can_not_get_the_infile_name = true;
        exit(3);
    }
    printf("%s\n", "");
    infile = fopen(infilename, "r");
    if(infile == NULL){
        printf("File %s can't be opened.\n", infilename);
        //@ ghost program_file_cannot_be_opened = true;
        exit(1);
    }
    //@ ghost symStreamIndex = -1;
    getsym();
    block(declbegsys|statbegsys|period);
    if(sym!=period){
        error(9);
        /*@ ghost stop_here = true; */
        exit(2);            // 增加该语句是为了避免验证错误恢复功能。
    }
    ret=fclose(infile);
    if(ret!=0){
        printf("File %s can't be closed", infilename);
        //@ ghost can_not_close_file = true;
        exit(4);
    }
    return 0;
}
